#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Yellow
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_color5 Lime
#property indicator_color6 Lime
#property indicator_color7 Lime
//---- indicator parameters
extern int    BandsPeriod       = 20;
extern int    BandsShift        = 0;
extern double BandsDeviations   = 1.0;
extern double BandsDeviations1  = 2.0;
extern double BandsDeviations2  = 3.0;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,0,3);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE,4,0);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE,2,0);
   SetIndexBuffer(2,LowerBuffer);
   SetIndexStyle(3,DRAW_LINE,4,0);
   SetIndexBuffer(3,UpperBuffer1);
   SetIndexStyle(4,DRAW_LINE,2,0);
   SetIndexBuffer(4,LowerBuffer1);
   SetIndexStyle(5,DRAW_LINE,4,0);
   SetIndexBuffer(5,UpperBuffer2);
   SetIndexStyle(6,DRAW_LINE,2,0);
   SetIndexBuffer(6,LowerBuffer2);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   SetIndexDrawBegin(3,BandsPeriod+BandsShift);
   SetIndexDrawBegin(4,BandsPeriod+BandsShift);
   SetIndexDrawBegin(5,BandsPeriod+BandsShift);
   SetIndexDrawBegin(6,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation,deviation1,deviation2;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]  =EMPTY_VALUE;
         UpperBuffer[Bars-i]   =EMPTY_VALUE;
         LowerBuffer[Bars-i]   =EMPTY_VALUE;
         UpperBuffer1[Bars-i]  =EMPTY_VALUE;
         LowerBuffer1[Bars-i]  =EMPTY_VALUE;
         UpperBuffer2[Bars-i]  =EMPTY_VALUE;
         LowerBuffer2[Bars-i]  =EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_EMA,PRICE_CLOSE,i);
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation  = BandsDeviations*MathSqrt(sum/BandsPeriod);
      deviation1 = BandsDeviations1*MathSqrt(sum/BandsPeriod);
      deviation2 = BandsDeviations2*MathSqrt(sum/BandsPeriod);
      UpperBuffer[i]  = oldval+deviation;
      LowerBuffer[i]  = oldval-deviation;
      UpperBuffer1[i] = oldval+deviation1;
      LowerBuffer1[i] = oldval-deviation1;
      UpperBuffer2[i] = oldval+deviation2;
      LowerBuffer2[i] = oldval-deviation2;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+